function colorModel = GenLocalColorModel(labimSet, K, oLSet, label)
% estimate global color model
% labim - image patch in Lab space
% K - number of component in mixture model
% select - what pixels in patch belongs to region

fg= [];
vectIm = [];
for i = 1:numel(labimSet)
    labim = labimSet{i};
    oL = oLSet{i};
    select = (oL==label);
    
    imsiz = size(labim);

    imR = labim(:,:,1);
    imG = labim(:,:,2);
    imB = labim(:,:,3);

    fullSize = prod(imsiz(1:2));

    tempvectIm = [reshape(imR, [1 fullSize]); reshape(imG, [1 fullSize]); reshape(imB, [1 fullSize])];
    vectIm = [vectIm, tempvectIm];

    selected = find(select);
    imR = imR(selected);
    imG = imG(selected);
    imB = imB(selected);
    tempfg = [imR, imG, imB];
    fg = [fg; tempfg];
end

[idx mu] = kmeans(fg, K, 'emptyaction','singleton');

% mu - mean
% cvr - covariance
% wi - component weight

colorModel = cell(K,1);
for ki=1:K
    colorModel{ki}.mu = mu(ki,:);
    colorModel{ki}.cvr = cov(fg(idx==ki,:));
    colorModel{ki}.wi = sum(idx==ki)./size(fg,1);
end
