activations = []; % 3 by N matrix, where N is an unknown large number
rand('seed', 20);
for i = 1:numImage
    % compute SUM2
    SUM1MAX1mapName = [working_add '/SUM1MAX1map' 'image' num2str(i) 'scale' num2str(1)];
    load(SUM1MAX1mapName, 'SUM1map');
    SUM2map = cell(nTransform*numCluster,numResolution);
    for iRes = 1:numResolution
        width = floor(size(SUM1map{iRes,1},2)/subsampleS2);
        height = floor(size(SUM1map{iRes,1},1)/subsampleS2);
        for j = 1:nTransform*numCluster
            map = single( rand( height, width ) );
            SUM2map{j,iRes} = single( rand( height, width ) );
        end
    end
    % exclude the near-boundary region
    for ii = 1:numel(SUM2map)
        SUM2map{ii}(:,[1:floor(templateSize(2)/2) end-floor(templateSize(2)/2):end]) = min(-1001,S2Thres-1);
        SUM2map{ii}([1:floor(templateSize(1)/2) end-floor(templateSize(1)/2):end],:) = min(-1001,S2Thres-1);
    end

    % compute MAX2, perform surround supression and get activations
    if strcmp('MatchingPursuit',supressionModeInEStep) == 1
        tmpActivations = mexc_ComputeMAX2MP( SUM2map, int32(locationPerturbationFraction*partSize/subsampleS2), -1000 );
    elseif strcmp('LocalSurroundSurpression',supressionModeInEStep) == 1
        subsampleM2 = 1;
        % warning: mexc_ComputeMAX2 does not handle multiscale image for now
        [MAX2map M2LocationTrace M2TemplateTrace M2RowColShift tmpActivations] = ...
            mexc_ComputeMAX2( templateAffinityMatrix, SUM2map, locationPerturbationFraction, ...
            int32(partSize/subsampleS2*ones(numCluster*nTransform,1)), subsampleM2 );
        tmpActivations = tmpActivations( :,tmpActivations(4,:) > -1000 );
    end
    activations = [activations,[single(i*ones(1,size(tmpActivations,2)));tmpActivations]];
end
initialClusters = activations;