function croppedSegMaps = cropSegmentationMap(mutiScaleLabelmapSet, activations, numCluster, segshapeTemplates, nTransform, numOrient, templateTransform, outRow, outCol)

activatedCluster = ceil( ( activations(5,:) + 1 ) / nTransform );
activatedTransform = activations(5,:) + 1 - (activatedCluster-1) * nTransform;
activatedImg = activations(1,:);

croppedSegMaps = cell(numCluster,1);
for cc = 1:numCluster
	ind = find(activatedCluster == cc);
	
	nMember = length(ind);
	cropped = cell(nMember,1);
	
    for iMember = 1:length(ind)
        % use mex-C code instead: crop S1 map
        % warning: if the templates are of different sizes, we need to alter outRow and outCol (use only a subset of it).
        destHeight = size(segshapeTemplates{cc},1); destWidth = size(segshapeTemplates{cc},2); nScale = 1;
        srcIm = mutiScaleLabelmapSet{activatedImg(ind(iMember))}{1+activations(4,ind(iMember))};
        tmpNumOrient = 1;
        
        iTransform = activatedTransform(ind(iMember));
        tScale = templateTransform{iTransform}(1); 
        actualPartRotation = templateTransform{iTransform}(4);
        reflection = templateTransform{iTransform}(5);
    
        cropped(iMember) = mexc_CropInstance( {single(srcIm)},...
            activations(2,ind(iMember))-1,...
            activations(3,ind(iMember))-1,...
            actualPartRotation,tScale,1,...
            outRow{activatedTransform(ind(iMember))},outCol{activatedTransform(ind(iMember))},...
            tmpNumOrient,nScale,destWidth,destHeight );
        if reflection < 0
            cropped{iMember} = flipdim(cropped{iMember},2);
        end
    end
    croppedSegMaps{cc} = cropped;
end