% transform the templates
[TransformedTemplate, templateAffinityMatrix] = genTransformedSketchTemplates(S2Templates, templateTransform, numOrient);
TransformedShapeSegModels = genTransformedShapeSegTemplates(shapeSegModels, inRow, inCol, outRow, outCol);

activations = []; % 3 by N matrix, where N is an unknown large number
for i = 1:numImage
    % compute SUM2
    SUM1MAX1mapName = [working_add '/SUM1MAX1map' 'image' num2str(i) 'scale' num2str(1)];
    load(SUM1MAX1mapName, 'SUM1map', 'MAX1map', 'M1RowShift', 'M1ColShift',...
                'M1OriShifted', 'J');
    SUM2map1 = cell(nTransform*numCluster,numResolution);
    SUM2map2 = cell(nTransform*numCluster,numResolution);
    SUM2map = cell(nTransform*numCluster,numResolution);
    for iRes = 1:numResolution
        SUM2map1(:,iRes) = mexc_ComputeSUM2( numOrient, MAX1map(iRes,:), TransformedTemplate, subsampleS2, DELTA );
        SUM2map2(:,iRes) = computeLabelSUM2(mSLset{i}{iRes}, TransformedShapeSegModels, templateSize);
    end
    % random perturbation (to break ties arbitrarily for MAX2)
    for ii = 1:numel(SUM2map)
%                 if iter >= numIter/3 && iter<numIter
%                     SUM2map1{ii}(SUM2map1{ii} < S2Thres/2) = min(-1001,S2Thres-1);
%                 end
        SUM2map{ii} = SUM2map1{ii} + SUM2map2{ii}*weightlabel;
        SUM2map{ii}(:) = SUM2map{ii}(:) + 1e-3 * ( rand(numel(SUM2map{ii}),1) - .5 );
    end
    % exclude the near-boundary region
    for ii = 1:numel(SUM2map)
        SUM2map{ii}(:,[1:floor(templateSize(2)/4) end-floor(templateSize(2)/4):end]) = min(-1001,S2Thres-1);
        SUM2map{ii}([1:floor(templateSize(1)/4) end-floor(templateSize(1)/4):end],:) = min(-1001,S2Thres-1);
    end

    % compute MAX2, perform surround supression and get activations
    if iter == 1
        thresh = -1000;
    else
        thresh = -100;
    end

    % discard the activated instances that have a low S2 score
    if iter > floor(numIter/2) % for the later iterations, increase the sparsity
        locationPerturbationFraction = locationPerturbationFraction_final;
    end
    if strcmp('MatchingPursuit',supressionModeInEStep) == 1
        tmpActivations = mexc_ComputeMAX2MP( SUM2map, int32(locationPerturbationFraction*partSize/subsampleS2), thresh);
    elseif strcmp('LocalSurroundSurpression',supressionModeInEStep) == 1
        subsampleM2 = 1;
        [MAX2map M2LocationTrace M2TemplateTrace M2RowColShift tmpActivations] = ...
            mexc_ComputeMAX2( templateAffinityMatrix, SUM2map, locationPerturbationFraction, ...
            int32(partSize/subsampleS2*ones(numCluster*nTransform,1)), subsampleM2 );
        tmpActivations = tmpActivations( :,tmpActivations(4,:) > thresh);
    end
    tmpActivations = [single(i*ones(1,size(tmpActivations,2)));tmpActivations];
    tmpActivatedCluster = ceil( ( tmpActivations(5,:) + 1 ) / nTransform );
    [tmp,tmpInd] = unique(tmpActivatedCluster, 'first');
    tmpActivations = tmpActivations(:,tmpInd);
    activations = [activations,tmpActivations];
end
activations(2:3,:) = activations(2:3,:) * subsampleS2;
activatedCluster = ceil( ( activations(5,:) + 1 ) / nTransform );
activatedTransform = activations(5,:) + 1 - (activatedCluster-1) * nTransform;
activatedImg = activations(1,:);
% disp(sprintf('on average %.2f activations per image',size(activations,2)/numImage));
numElement = numElementLimit;