function colorModel = genColorModel(LSet, mScaleImSet, activations, K, label, nTransform, numOrient, templateTransform, partSizeX, partSizeY)
% activatedCluster = ceil( ( activations(5,:) + 1 ) / nTransform );

maskedSegmentationMapSet = {};
for img = 1:numel(mScaleImSet)
    ind = (activations(1,:) == img);
    maskedSegmentationMapSet{img} = genMaskedSegmentationMap(LSet{img}, mScaleImSet{img}, activations(:,ind), nTransform, numOrient, templateTransform, partSizeX, partSizeY);
end

imSet = {};
for img = 1:numel(mScaleImSet)
    imSet{img} = double(mScaleImSet{img}{end});
end

colorModel = GenLocalColorModel(imSet, K, maskedSegmentationMapSet, label);