addpath('./GCmex2.0');
border = 5;

partSizeX = templateSize(1);
partSizeY = templateSize(2);

% read the training examples
Iname = dir('positiveImage/*.jpg');
n = length(Iname);
selected_img = 1:n;

imSet = {};
initMapSet = {};
for img = selected_img

	% load SUM1/MAX1 map
	multipleResolutionImageName = [working_add '/multipleResolutionImage' num2str(img)];
	load(multipleResolutionImageName, 'Jc');
	% find activations
	ind = find( activations(1,:) == img );
	
	maskMap = genInitSegMap(Jc, activations(:,ind), nTransform, numOrient, rotationRange, partSizeX, partSizeY, border);
    
    imSet{img} = double(Jc{end});
    initMapSet{img} = maskMap;
    
%     [L, dc , sc, vC, hC] = GrabCut(double(Jc{end}), maskMap);
%        
%     L3 = repmat(L,[1,1,3]);
%     resIm = Jc{end};
%     resIm(L3==-1) = 255;
%     figure;imshow(resIm);
end

segshapeTemplates = cell(numCluster,1);
for cc = 1:numCluster
    segshapeTemplates{cc} = repmat(0.5, partSizeX, partSizeY);
end




%iterate between update segmentation shape prior and segment
for round = 1:3
    shapePriorMapSet = {};
    for img = selected_img
        % load SUM1/MAX1 map
        multipleResolutionImageName = [working_add '/multipleResolutionImage' num2str(img)];
        load(multipleResolutionImageName, 'Jc');
        % find activations
        ind = find( activations(1,:) == img );

        shapePriorMap = genshapePriorMap(Jc, activations(:,ind), segshapeTemplates, nTransform, numOrient, rotationRange, border);

        shapePriorMapSet{img} = shapePriorMap;
    end

    [LSet, dcSet , scSet, vCSet, hCSet] = CoGrabCut(imSet, initMapSet, shapePriorMapSet);

    croppedSegMapSet = {};
    mSLset = cell(selected_img,1);
    for img = selected_img
        multipleResolutionImageName = [working_add '/multipleResolutionImage' num2str(img)];
        load(multipleResolutionImageName, 'Jc');
        
        for s = 1:numel(Jc)
            scale = size(Jc{s},1)/size(LSet{img},1);
            mSLset{img}{s} = imresize(LSet{img},scale);
        end
        
%         L3 = repmat(LSet{img},[1,1,3]);
%         resIm = Jc{end};
%         resIm(L3==-1) = 255;
%         figure;imshow(resIm);
    end
    croppedSegMaps = cropSegmentationMap(mSLset, activations, numCluster, segshapeTemplates, nTransform, numOrient, rotationRange, outRow, outCol);
    
    for cc = 1:numCluster
        dim = ndims(croppedSegMaps{cc}{1});          %# Get the number of dimensions for your arrays
        M = cat(dim+1,croppedSegMaps{cc}{:});        %# Convert to a (dim+1)-dimensional matrix
        meanArray = mean(M,dim+1);
        segshapeTemplates{cc} = (meanArray+1)/2;
    end
end



