function maskMap = genInitSegMap(Jc, activations, nTransform, numOrient, templateTransform, partSizeX, partSizeY, border)
% initialize the mask of bounding boxes and sketched image
maskMap = zeros(size(Jc{end},1),size(Jc{end},2)); % the bounding box map is of the highest resolution
    
for t = 1:size(activations,2) % for each activated template (or codeword, or part) 

    iCluster = ceil( ( activations(5,t) + 1 ) / nTransform );
    iTransform = activations(5,t) + 1 - (iCluster-1) * nTransform;
    iRes = activations(4,t) + 1;

    scaling = double(size(Jc{end},1)) / double(size(Jc{iRes},1));
    
    largerPartSizeX = floor(partSizeX * scaling+.5);
    largerPartSizeY = floor(partSizeY * scaling+.5);

    inRow = single([-floor(largerPartSizeX/2),floor(largerPartSizeX/2),floor(largerPartSizeX/2),-floor(largerPartSizeX/2),-floor(largerPartSizeX/2)]);
    inCol = single([floor(largerPartSizeY/2),floor(largerPartSizeY/2),-floor(largerPartSizeY/2),-floor(largerPartSizeY/2),floor(largerPartSizeY/2)]);
    inO = zeros(numel(inRow),1,'single'); inS = zeros(numel(inRow),1,'single');
   % actualPartRotation = iTransform-1;
    tScale = templateTransform{iTransform}(1); 
	rScale = templateTransform{iTransform}(2);
	cScale = templateTransform{iTransform}(3);
    actualPartRotation = templateTransform{iTransform}(4);
    reflection = templateTransform{iTransform}(5);
    
    if reflection < 0
        inCol = -inCol+1;
    end
                
    [outRow, outCol] = ...
        mexc_TemplateAffineTransform(tScale,rScale,cScale,...
            actualPartRotation,inRow,inCol,inO,inS,numOrient);

    

    outRow = floor(.5 + outRow + activations(2,t)*scaling);
    outCol = floor(.5 + outCol + activations(3,t)*scaling);

    % directly overwrite the corresponding pixels
    outRow(outRow < 1) = 1;
    outRow(outRow > size(maskMap,1)) = size(maskMap,1);
    outCol(outCol < 1) = 1;
    outCol(outCol > size(maskMap,2)) = size(maskMap,2);

    tempMask = poly2mask(double(outCol),double(outRow),size(maskMap,1),size(maskMap,2));

    maskMap(tempMask == 1) = 1;

end

maskMap(1:border,1:end) = -1;
maskMap(:,1:border) = -1;
maskMap(end-border:end,:) = -1;
maskMap(:,end-border:end) = -1;

  