function TransformedShapeSegModels = genTransformedShapeSegTemplates(shapeSegModels, inRow, inCol, outRow, outCol)
minRow=0;maxRow=0;minCol=0;maxCol=0;
nT = numel(outRow);
numCluster = numel(shapeSegModels);
TransformedShapeSegModels = cell(nT,numCluster);

for iT=1:nT
    minRow = min(minRow,min(outRow{iT}));
    maxRow = max(maxRow,max(outRow{iT}));
    minCol = min(minCol,min(outCol{iT}));
    maxCol = max(maxCol,max(outCol{iT}));
end
minInRow=min(inRow);
minInCol=min(inCol);

maxSize = [maxRow-minRow+1,maxCol-minCol+1];
for iT=1:nT
    curOutRow = outRow{iT};
    curOutCol = outCol{iT};
    for cc = 1:numCluster
        TransformedShapeSegModels{iT,cc} = repmat(0.5, [maxSize(1),maxSize(2),2]);
        for i = 1:length(curOutRow)
            TransformedShapeSegModels{iT,cc}(curOutRow(i)-minRow+1,curOutCol(i)-minCol+1,1)=shapeSegModels{cc}(inRow(i)-minInRow+1,inCol(i)-minInCol+1);
        end
        TransformedShapeSegModels{iT,cc}(:,:,2) = 1-TransformedShapeSegModels{iT,cc}(:,:,1);
        TransformedShapeSegModels{iT,cc}(:,:,1) = log(TransformedShapeSegModels{iT,cc}(:,:,1));
        TransformedShapeSegModels{iT,cc}(:,:,2) = log(TransformedShapeSegModels{iT,cc}(:,:,2));
    end
end