function [TransformedTemplate, templateAffinityMatrix] = genTransformedSketchTemplates(S2Templates, templateTransform, numOrient)
numCluster = numel(S2Templates);
nTransform = numel(templateTransform);

TransformedTemplate = cell(nTransform,numCluster);
% CHANGE XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
for cc = 1:numCluster
    selectedScale = S2Templates{cc}.selectedScale;
    for iT = 1:nTransform
        templateScaleInd = templateTransform{iT}(1);
        rowScale = templateTransform{iT}(2);
        colScale = templateTransform{iT}(3);
        rotation = templateTransform{iT}(4);
        reflection = templateTransform{iT}(5);

        curSelectedRow = S2Templates{cc}.selectedRow;
        curSelectedCol = S2Templates{cc}.selectedCol;
        curSelectedOri = S2Templates{cc}.selectedOri;
        if reflection < 0
            curSelectedCol = -curSelectedCol+1;
            curSelectedOri = numOrient-curSelectedOri;
            temp_ind = (curSelectedOri >= numOrient);
            curSelectedOri(temp_ind) = curSelectedOri(temp_ind) - numOrient;
            temp_ind = (curSelectedOri < 0);
            curSelectedOri(temp_ind) = curSelectedOri(temp_ind) + numOrient;
        end
        [tmpSelectedRow tmpSelectedCol tmpSelectedOri tmpSelectedScale] = ...
            mexc_TemplateAffineTransform( templateScaleInd, rowScale,...
            colScale, rotation, curSelectedRow, curSelectedCol,...
            curSelectedOri, selectedScale, numOrient);
        TransformedTemplate{iT,cc}.selectedRow = tmpSelectedRow;
        TransformedTemplate{iT,cc}.selectedCol = tmpSelectedCol;
        TransformedTemplate{iT,cc}.selectedOri = tmpSelectedOri;
        TransformedTemplate{iT,cc}.selectedScale = tmpSelectedScale;
        TransformedTemplate{iT,cc}.selectedLambda = S2Templates{cc}.selectedLambda;
        TransformedTemplate{iT,cc}.selectedLogZ = S2Templates{cc}.selectedLogZ;
    end
end

% prepare for affinity matrix
templateAffinityMatrix = cell( numCluster * nTransform, 1 );
for cc = 1:numCluster
    % from = (cc-1)*nTransform + 1;
    % to = cc * nTransform;
    from = 1; to = nTransform*numCluster;
    for jj = 1:nTransform
        templateAffinityMatrix{jj+(cc-1)*nTransform} = int32((from:to)-1);
    end
end