activatedImg = activations(1,:);
activations(:, activatedImg>learnRange) = [];
activations(2:3,:) = activations(2:3,:) * subsampleS2;
activatedCluster = ceil( ( activations(5,:) + 1 ) / nTransform );
activatedTransform = activations(5,:) + 1 - (activatedCluster-1) * nTransform;
activatedImg = activations(1,:);

syms = cell(numCluster,1);
S2Templates = cell(numCluster,1);

for cc = 1:numCluster
    for k = 1:buf_length
        fprintf(1,'\b');
    end
    str = sprintf('run %d: learning iteration %d for cluster %d',iRS,iter,cc);
    fprintf(1,str); drawnow;
    buf_length = length(str);

    selectedOrient = zeros(1, numElement, 'single');  % orientation and location of selected Gabors
    selectedx = zeros(1, numElement, 'single'); 
    selectedy = zeros(1, numElement, 'single'); 
    selectedlambda = zeros(1, numElement, 'single'); % weighting parameter for scoring template matching
    selectedLogZ = zeros(1, numElement, 'single'); % normalizing constant
    commonTemplate = single(zeros(sizeTemplatex, sizeTemplatey)); % template of active basis 
    % =====================================
    % crop back and relearn
    % =====================================
    ind = find(activatedCluster == cc);
    mixing(cc) = length(ind);
    aveLogL(cc) = mean(activations(6,ind));
    if isnan(aveLogL(cc))
        aveLogL(cc) = -1;
    end
    % sample a subset of training postitives, if necessary
    if length(ind) > maxNumClusterMember
        idx = randperm(length(ind));
        ind = ind(idx(1:maxNumClusterMember));
        ind = sort(ind,'ascend');
    end
    nMember = length(ind);
    SUM1mapLearn = cell(nMember,numOrient);
    MAX1mapLearn = cell(nMember,numOrient);
    ARGMAX1mapLearn = cell(nMember,numOrient);
    cropped = cell(nMember,1);
    currentImg = -1;
    for iMember = 1:length(ind)
        if activatedImg(ind(iMember)) ~= currentImg
            currentImg = activatedImg(ind(iMember));
            SUM1MAX1mapName = [working_add '/SUM1MAX1map' 'image' num2str(currentImg) 'scale' num2str(1)];
            load(SUM1MAX1mapName, 'SUM1map', 'J' );
        end
        % use mex-C code instead: crop S1 map
        % warning: if the templates are of different sizes, we need to alter outRow and outCol (use only a subset of it).
        iT = activatedTransform(ind(iMember));
        tScale = templateTransform{iT}(1); rotation = templateTransform{iT}(4); destHeight = templateSize(1); destWidth = templateSize(2); nScale = 1; reflection = templateTransform{iT}(5);
        SUM1mapLearn(iMember,:) = mexc_CropInstance( SUM1map(1+activations(4,ind(iMember)),:),...
            activations(2,ind(iMember))-1,...
            activations(3,ind(iMember))-1,...
            rotation,tScale,1,...
            outRow{iT},outCol{iT},...
            numOrient,nScale,destWidth,destHeight );
        if reflection < 0
            SUM1mapLearn(iMember,:) = mirrorOrienImages(SUM1mapLearn(iMember,:));
        end

        % Crop detected image patch for visualization
        srcIm = J{1+activations(4,ind(iMember))};
        tmpNumOrient = 1;
        cropped(iMember) = mexc_CropInstance( {single(srcIm)},...
            activations(2,ind(iMember))-1,...
            activations(3,ind(iMember))-1,...
            rotation,tScale,1,...
            outRow{iT},outCol{iT},...
            tmpNumOrient,nScale,destWidth,destHeight );
        if reflection < 0
            cropped{iMember} = flipdim(cropped{iMember},2);
        end

        % local max
        subsampleM1 = 1;
        [M1 ARGMAX1 M1RowShift M1ColShift M1OriShifted] = ...
            mexc_ComputeMAX1(numOrient, SUM1mapLearn(iMember,:), locationShiftLimit,...
                orientShiftLimit, subsampleM1 );
        MAX1mapLearn(iMember,:) = M1;
        ARGMAX1mapLearn(iMember,:) = ARGMAX1;
    end
    im = displayImages(cropped,10,60,60);
    if ~isempty(im)
        imwrite(im,sprintf('%s/cluter%d_iter%d.png',output_dir,cc,iter));
    end

    % now start re-learning
    commonTemplate = single(zeros(templateSize(1), templateSize(2)));  
    deformedTemplate = cell(1, nMember); % templates for training images 
    for ii = 1 : nMember
        deformedTemplate{ii} = single(zeros(templateSize(1), templateSize(2)));  
    end

    if (iter<numIter) 
         mexc_SharedSketch(numOrient, locationShiftLimit, orientShiftLimit, subsampleM1, ... % about active basis  
           numElement, numElementPointer, 0., nMember, templateSize(1), templateSize(2), ...
           SUM1mapLearn, MAX1mapLearn, ARGMAX1mapLearn, ... % about training images
           halfFilterSize, Correlation, allSymbol(1, :), ... % about filters
           numStoredPoint, storedlambda, storedExpectation, storedLogZ, ... % about exponential model 
           selectedOrient, selectedx, selectedy, selectedlambda, selectedLogZ, ... % learned parameters
           commonTemplate, deformedTemplate, ... % learned templates 
           M1RowShift, M1ColShift, M1OriShifted); % local shift parameters
    else         
        mexc_SharedSketch(numOrient, locationShiftLimit, orientShiftLimit, subsampleM1, ... % about active basis  
           numElement, numElementPointer, expectationThreshold, nMember, templateSize(1), templateSize(2), ...
           SUM1mapLearn, MAX1mapLearn, ARGMAX1mapLearn, ... % about training images
           halfFilterSize, Correlation, allSymbol(1, :), ... % about filters
           numStoredPoint, storedlambda, storedExpectation, storedLogZ, ... % about exponential model 
           selectedOrient, selectedx, selectedy, selectedlambda, selectedLogZ, ... % learned parameters
           commonTemplate, deformedTemplate, ... % learned templates 
           M1RowShift, M1ColShift, M1OriShifted); % local shift parameters
    end
    if nMember > 0
        numElementActual = numElementPointer(1);
    else
        numElementActual = 0;
    end
    numElementAll(cc) = numElementActual; 
    selectedOrientActual = selectedOrient(1:numElementActual); 
    selectedxActual = selectedx(1:numElementActual); 
    selectedyActual = selectedy(1:numElementActual); 
    selectedlambdaActual = selectedlambda(1:numElementActual); 
    selectedLogZActual = selectedLogZ(1:numElementActual); 
    save([working_add sprintf( '/learnedmodel%d_iter%d.mat',cc,iter)], 'numElementActual', 'selectedOrientActual',...
        'selectedxActual', 'selectedyActual', 'selectedlambdaActual', 'selectedLogZActual',...
        'commonTemplate');
    selectedOrient = selectedOrientActual; 
    selectedx = selectedxActual; 
    selectedy = selectedyActual; 
    selectedlambda = selectedlambdaActual; 
    selectedLogZ = selectedLogZActual; 
    S2Templates{cc} = struct( 'selectedRow', single(selectedx -1 - floor(templateSize(1)/2)),...
        'selectedCol', single(selectedy -1 - floor(templateSize(2)/2)), ...
        'selectedOri', single(selectedOrient), 'selectedScale', zeros(length(selectedx),1,'single'), ...
        'selectedLambda', single(selectedlambda), 'selectedLogZ', single(selectedLogZ), 'commonTemplate', commonTemplate );

    syms{cc} = -commonTemplate;
end
numElementLimit = numElement; 
%towrite = displayImages(syms,10,templateSize(1),templateSize(2));
%imwrite(towrite,sprintf('output/template_iter%d.png',iter));

for cc=1:numCluster
    towrite=zeros(size(syms{cc},1),size(syms{cc},2))+1.0;
    [posx,posy]=find(syms{cc}(:,:)<-0.1);
    for jj=1:length(posx)
        towrite(posx(jj),posy(jj))=0.;
    end;      
    towrite=towrite;
    imwrite(towrite,sprintf('%s/template%d_iter%d.png',output_dir,cc,iter));
end;
