activations = bestActivations;
S2Templates = bestS2Templates;
activatedImg = activations(1,:);
activatedCluster = ceil( ( activations(5,:) + 1 ) / nTransform ); % starts from 1
activatedTransform = activations(5,:) + 1 - (activatedCluster-1) * nTransform; % starts from 1
mixing = bestMixing;
aveLogL = bestAveLogL;
cluster_is_nonempty = zeros(numCluster,1);
for cc = 1:numCluster
	ind = find(activatedCluster == cc);
	% sample a subset of training postitives, if necessary
	if length(ind) > maxNumClusterMember
		idx = randperm(length(ind));
		ind = ind(idx(1:maxNumClusterMember));
		ind = sort(ind,'ascend'); % make sure the imageNo is still in ascending order
	end
	
	nMember = length(ind);
	cropped = cell(nMember,1);
	currentImg = -1;
	for iMember = 1:length(ind)
		if activatedImg(ind(iMember)) ~= currentImg
			currentImg = activatedImg(ind(iMember));
			SUM1MAX1mapName = [working_add '/SUM1MAX1map' 'image' num2str(currentImg) 'scale' num2str(1)];
			load(SUM1MAX1mapName, 'J' );
        end

		% Crop detected image patch for visualization
		srcIm = J{1};
		tmpNumOrient = 1;
        iT = activatedTransform(ind(iMember));
        tScale = templateTransform{iT}(1); rotation = templateTransform{iT}(4); destHeight = templateSize(1); destWidth = templateSize(2); nScale = 1; reflection = templateTransform{iT}(5);
        cropped(iMember) = mexc_CropInstance( {single(srcIm)},...
            activations(2,ind(iMember))-1,...
            activations(3,ind(iMember))-1,...
            rotation,tScale,1,...
            outRow{activatedTransform(ind(iMember))},outCol{activatedTransform(ind(iMember))},...
            tmpNumOrient,nScale,destWidth,destHeight );
        if reflection < 0
            cropped{iMember} = flipdim(cropped{iMember},2);
        end
	end
	
	if ~isempty(ind) % cluster is not empty
		im = displayImages(cropped,10,templateSize(1),templateSize(2));
		imwrite(im,sprintf('%s/cluster%d.png',output_dir,cc));
		cluster_is_nonempty(cc) = 1;
		syms{cc} = -single(S2Templates{cc}.commonTemplate);
	end
end

% calculate the number of templates per image
for ii=1:numImage
    ind=find(activations(1,:)==ii);
    activatedCluster = ceil( ( activations(5,ind) + 1 ) / nTransform );
    numCI(ii,:)=hist(activatedCluster,1:numCluster);
end;
numPOS=numImage;
totalACT=size(activations,2);
totalL=sum(bestAveLogL);
save([working_add,'/learning_result.mat'],'bestActivations','bestS2Templates','bestOverallScore','bestInitialClusters','bestAveLogL','bestMixing', 'numElementAll');

% rank the learned templates
nonempty_clusters = find(cluster_is_nonempty);
mixing = mixing(nonempty_clusters);
aveLogL = aveLogL(nonempty_clusters);
syms = syms(nonempty_clusters);
syms2 = syms;
numElementAll = numElementAll(nonempty_clusters);
[sorted idx] = sort( (mixing) .* aveLogL, 'descend' );  % CHANGE XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
numElementAllsort = numElementAll(idx); 

for i = 1:numel(sorted)
    towrite = syms{idx(i)};
    if range(towrite) < 1
        towrite(:) = 255;
    else
        towrite = uint8(255 * (towrite-min(towrite(:)))/(max(towrite(:))-min(towrite(:))));
        towrite = double(towrite) - 50;
    end
    syms2{i} = towrite;
end
towrite = displayImages( syms2, 10, templateSize(1), templateSize(2), false );
imwrite(towrite,sprintf('./%s/template_sorted.png',output_dir));
tempOrder=idx;
numActiveClusters=length(nonempty_clusters);

% show the color templates
colors = colormap(hsv(numCluster));
non_empty_cluster=find(cluster_is_nonempty);
for cc=1:length(non_empty_cluster)
    towrite=zeros(size(syms{cc},1),size(syms{cc},2),3)+1.;
    [posx,posy]=find(syms{cc}(:,:)<-0.1);
    for jj=1:length(posx)
        cpos=find(cc==tempOrder);
        towrite(posx(jj),posy(jj),:)=colors(cpos,:);
    end;
    imwrite(towrite,sprintf('./%s/color_template%d.png',output_dir,cc));
end;